#version 400
uniform vec3 lightPosition;
uniform vec3 colorWater;
uniform vec3 colorAtm;
uniform vec3 color1;
uniform vec3 color2;
uniform vec3 color3;

in vec3 interpolatedPosition;
in vec3 interpolatedLocalPosition;
in vec3 interpolatedNormal;

//Source: https://www.shadertoy.com/view/Xsl3Dl
vec3 hash(vec3 p) {
    p = vec3( dot(p, vec3(127.1,311.7, 74.7)),
              dot(p, vec3(269.5,163.3,226.1)),
              dot(p, vec3(113.5,271.9,124.6)));

    return -1.0 + 2.0*fract(sin(p)*43758.5453123);
}

//Source: https://www.shadertoy.com/view/Xsl3Dl
float noise(in vec3 p) {
    vec3 i = floor( p );
    vec3 f = fract( p );

    vec3 u = f*f*(3.0-2.0*f);

    return mix( mix( mix( dot( hash( i + vec3(0.0,0.0,0.0) ), f - vec3(0.0,0.0,0.0) ),
                          dot( hash( i + vec3(1.0,0.0,0.0) ), f - vec3(1.0,0.0,0.0) ), u.x),
                     mix( dot( hash( i + vec3(0.0,1.0,0.0) ), f - vec3(0.0,1.0,0.0) ),
                          dot( hash( i + vec3(1.0,1.0,0.0) ), f - vec3(1.0,1.0,0.0) ), u.x), u.y),
                mix( mix( dot( hash( i + vec3(0.0,0.0,1.0) ), f - vec3(0.0,0.0,1.0) ),
                          dot( hash( i + vec3(1.0,0.0,1.0) ), f - vec3(1.0,0.0,1.0) ), u.x),
                     mix( dot( hash( i + vec3(0.0,1.0,1.0) ), f - vec3(0.0,1.0,1.0) ),
                          dot( hash( i + vec3(1.0,1.0,1.0) ), f - vec3(1.0,1.0,1.0) ), u.x), u.y), u.z );
}

void main() {

    //-- Task 2 -- Calculate f by combining multiple noise layers with different density
    //Right now it applies only one map
    float f = 0.0;
    f += 1.0 * noise(3.0 * interpolatedLocalPosition);


    //-- Task 3 -- Find the color of the fragment. For that use the noise threshold.
    //For example if the threshold is smaller than 0 (or some other number) then use blue color (water).

    //-- Task 4 -- Add the phong or blinn lightning model

    //-- Task 5 -- Add specular highlight only to the water (not to the land)

    //-- Task 6 -- Add atmosphere glow effect
    //Hint: Use the cosine of the angle between the vector towards the camera and surface normal

    gl_FragColor = vec4(vec3(f + 0.5), 1.0);
}
