#version 400
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrix;

in vec3 position;
in vec3 normal;

out vec3 interpolatedLocalPosition; //We interpolate the local position of fragment
out vec3 interpolatedPosition; //This is camera space
out vec3 interpolatedNormal; //This is in camera space

void main() {
    mat3 normalMatrix = transpose(inverse(mat3(viewMatrix * modelMatrix)));

    interpolatedLocalPosition = position;
    interpolatedPosition = (viewMatrix * modelMatrix * vec4(position, 1.0)).xyz;
    interpolatedNormal = normalize(normalMatrix * normal);

    gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1.0);
}
